<?
// plugin needs to work on Nucleus versions <=2.0 as well
if (!function_exists('sql_table')){
	function sql_table($name) {
		return 'nucleus_' . $name;
	}
}

class NP_EzComment extends NucleusPlugin {
	function getEventList() { return array(); }
	function getName() { return 'Ez Comment'; }
	function getAuthor() { return 'Taka'; }
	function getURL() { return 'http://vivian.stripper.jp/'; }
	function getVersion() { return '0.2'; }
	function getDescription() {
		return 'Insert a comment form and a list of comments. &lt;%EzComment%&gt;, &lt;%EzComment(5)%&gt;, &lt;%EzComment(form)%&gt; or &lt;%EzComment(list,10)%&gt; on your template.';
	}
	function supportsFeature($what) {
		switch($what){
			case 'SqlTablePrefix':
				return 1;
			default:
				return 0;
		}
	}

	function doTemplateVar(&$item, $type='', $limit=10){
		global $CONF, $manager, $member, $catid;

/* * * 設定 * * * * * * * * * * * * * * * * * * * * * * * * * * */

/* 1コメント表示文字数 */
$trimwidth = 70;

/*****
  コメント表示とフォームの上下の順序
  1：フォーム
  2：コメント表示
  カッコの中を表示したい順にカンマで区切って記入
*****/
$line = array(1,2);
//$line = array(2,1); //←上下逆にしたい時はこっち

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

		$params = func_get_args();
		if(intval($params[1])){
			$limit = $params[1];
		}
		if($type != 'list' && $type != 'form') $type = '';
		$limit = intval($limit);

		$itemid = $item->itemid;
		$linkparams = array();
		if($catid) $linkparams['catid'] = $catid;
		$itemuri = createItemLink($itemid, $linkparams);
		
		$blogid = getBlogIDFromItemID($itemid);
		$settings =& $manager->getBlog($blogid);
		$settings->readSettings();
		
		$membername = $member->getDisplayName();

		foreach($line as $val){
			switch($val){
				case 1:
					if((!$membername && !$settings->commentsEnabled()) || $type == 'list'){
						break;
					}else{
						$this->showForm($itemid,$itemuri,$membername);
					}
					break;
				case 2:
					if($type != 'form'){
						$this->showComment($limit,$itemid,$itemuri,$trimwidth);
					}
					break;
			}
		}
	}


// FORM START ---------------------------------------
function showForm($itemid,$itemuri,$membername){
	global $CONF;

		$actionphp = $CONF['ActionURL'];

if($membername){ // member
	$nameArea = 'Name: '.$membername. ' (<a href="?action=logout">ログアウト</a>)';
	$mailArea = ' ';
	$checkBox = '';
	
}else{ // non member
		if(cookieVar('comment_user')){
			$username = htmlspecialchars(cookieVar('comment_user'));
		}else{
			$username = '';
		}
		if(cookieVar('comment_userid')){
			$userid = htmlspecialchars(cookieVar('comment_userid'));
		}else{
			$userid = '';
		}
		cookieVar('comment_user') ? $check = 'checked="checked" ' : $check = '';
			
	$nameArea = 'Name: <input name="user" value="'.$username.'" size="10" maxlength="60" class="formfield" />';
	$mailArea = 'Mail/URL: <input name="userid" value="'.$userid.'"size="20" maxlength="60" class="formfield" /><br />';
	$checkBox = '<input type="checkbox" value="1" name="remember" '.$check.'/>情報を記憶しておく ';
}

echo <<<___COMMENTFORM__

<form method="post" action="{$actionphp}"> 
	<div class="commentform"> 
		<input type="hidden" name="action" value="addcomment" />
	<!-- redirect URL -->
		<input type="hidden" name="url" value="{$itemuri}" />
		<input type="hidden" name="itemid" value="{$itemid}" />
	<!-- TextArea -->
		この記事にコメント:<br />
		<textarea name="body" cols="43" rows="3" class="formfield"></textarea><br />
	<!-- Name and Checkbox -->
		{$nameArea}
	<!-- Mail or URL -->
		{$mailArea}
	<!-- Submit buttom -->
		 {$checkBox}<input type="submit" value="送信" class="formbutton" />
  </div> 
</form>

___COMMENTFORM__;

	}
// FORM END -----------------------------------------


// LIST START ---------------------------------------
	function showComment($limit,$itemid,$itemuri,$trimwidth){
		
		$query =  'SELECT c.cnumber, c.cbody, c.cuser, c.cmember'
		       . ' FROM '.sql_table('comment').' as c'
		       . ' WHERE c.citem=' . $itemid 
		       . ' ORDER BY c.ctime ASC';
		if($limit) $query .=' LIMIT 0,'.$limit;

		$comments = sql_query($query);
		$viewnum = mysql_num_rows($comments);
		
		if($limit && ($viewnum == $limit)){
			$q = 'SELECT COUNT(*) FROM '.sql_table('comment').' as c WHERE c.citem=' . $itemid;
			$res = sql_query($q);
			$postnum = mysql_fetch_row($res);
		}else{
			$postnum = array($viewnum);
		}

		if($postnum[0]){ //コメントある時だけ表示
				
	/* comment-list-header */
			// $viewnumが表示数, $postnum[0]が総数。リミット無しの時これらは同数。

			echo '<div class="commentlist">'."\n".'--- コメント '.$viewnum;
			if($postnum[0]>$viewnum){
				echo '/'.$postnum[0];
			}else{
				echo '件';
			} // アンカー適当に変えるor外してください
			echo ' [ <a href="'.$itemuri.'#comment">全文表示</a> ] ---'."\n".'<ul>'."\n";

			while($row = mysql_fetch_object($comments)){
				$body = strip_tags($row->cbody);
				$body = str_replace("\r\n", "\r", $body); 
				$body = str_replace("\r", "\n", $body); 
				$body = str_replace("\n",' ',$body);
				$body = mb_strimwidth($body, 0, $trimwidth, "...", _CHARSET);
					
				$uri = $itemuri.'#c'.$row->cnumber;
				
				if (!($myname = $row->cuser)){
					$mem = new MEMBER;
					$mem->readFromID($row->cmember);
					$myname = $mem->getDisplayName();
				}

		/* comment-list-body */
				echo '  <li><a href="' .$uri. '">' .$myname. ' : ' .$body. '</a></li>'."\n";

			}
		/* comment-list-footer */
			echo '</ul>'."\n".'</div>'."\n";

			mysql_free_result($comments);
		}
	}
// LIST END -----------------------------------------

}